      PROGRAM MAJDEMO

      COMMON /MAUSER/ MAFLAG(20),CUTM(12),PARM(30)
      COMMON /MAKINE/ EP,EE,S,SHAT,Q2,W2,X,Y,PNT,PNL,YN,EN,PLT,YL
      COMMON /LUJETS/ N,K(4000,5),P(4000,5),V(4000,5)
      COMMON /LUDAT1/ MSTU(200),PARU(200),MSTJ(200),PARJ(200)
      PARAMETER (NHBOOK=100000)
      COMMON /PAWC/ BLANC(NHBOOK)
      REAL BINSIZ(4)
      NSIM=1000
      NBIN=100

C--       set mixing
      PARM(5)=0.01

C--       shut off hadronisation
      MAFLAG(5)=0

      BINSIZ(1)=1./REAL(NBIN)
      BINSIZ(2)=1./REAL(NBIN)
      BINSIZ(3)=100./REAL(NBIN)
      BINSIZ(4)=10./REAL(NBIN)

C--       book diagrams
      CALL HLIMIT(NHBOOK)
      CALL HROPEN(1,'DUMMY','majdemo.hbook','N',1024,ISTAT)
      CALL HBOOK1(1,'x',NBIN,0.,1.,0.)
      CALL HBOOK1(2,'y',NBIN,0.,1.,0.)
      CALL HBOOK1(3,'Transverse momentum of lepton',NBIN,0.,100.,0.)
      CALL HBOOK1(4,'Rapidity of lepton',NBIN,-5.,5.,0.)
      NPRINT=INT(RLU(0)*NSIM)+1

C--       set electron and proton momentum
      PARM(3)=30.
      PARM(2)=820.
C--       set heavy Majorana neutrino mass
      PARM(1)=100.

C--       choose appropriate h-functions
C--       at HERA (30+820), mN=100
      MAFLAG(11)=2
      MAFLAG(13)=1
      MAFLAG(15)=2
C--       at LEP/LHC (50+8000), mN=100
C      MAFLAG(11)=-1
C      MAFLAG(13)=-1
C      MAFLAG(15)=2
C--       at LEP/LHC (50+8000), mN=300
C      MAFLAG(11)=-1
C      MAFLAG(13)=-1
C      MAFLAG(15)=2
C--       at LEP/LHC (50+8000), mN=500
C      MAFLAG(11)=-2
C      MAFLAG(13)=-1
C      MAFLAG(15)=2
C--       at LEP/LHC (50+8000), mN=700
C      MAFLAG(11)=-2
C      MAFLAG(13)=-1
C      MAFLAG(15)=2

      CALL MAINIT

C--       generate NSIM events
      DO 100 JO=1,NSIM

C--       simulate an event according to the crossection
      CALL MAJOR

      IF (JO.EQ.NPRINT) CALL LULIST(1)

C--       fill histos
      CALL HF1(1,X,1.)
      CALL HF1(2,Y,1.)
      CALL HF1(3,PLU(K(4,4),10),1.)
      CALL HF1(4,PLU(K(4,4),17),1.)

100   CONTINUE

C--      Finalise histos and write output
      TOT=PARM(21)+PARM(23)+PARM(25)
      DO 200 JO=1,4
         CALL HOPERA(JO,'+',JO,JO,TOT/REAL(NSIM)/BINSIZ(JO),0.)
200   CONTINUE

      CALL HROUT(0,ICYCLE,'T')
      CALL HREND('DUMMY')
      CLOSE(1)

      WRITE(*,*) 
      WRITE(*,*) 'Number of simulated events:',NSIM
      WRITE(*,*) 'The total cross-section for e- P --> e+ W- X =',
     ,            PARM(21),' [pb]'
      WRITE(*,*) 'With an estimated standard deviation of:',
     ,            PARM(22),' [pb]'
      WRITE(*,*) 'The total cross-section for e- P --> e- W+ X =',
     ,            PARM(23),' [pb]'
      WRITE(*,*) 'With an estimated standard deviation of:',
     ,            PARM(24),' [pb]'
      WRITE(*,*) 'The total cross-section for e- P --> nu Z X =',
     ,            PARM(25),' [pb]'
      WRITE(*,*) 'With an estimated standard deviation of:',
     ,            PARM(26),' [pb]'

      END

